/* s__.h		-*- C++ -*-
 *$Header: /al/acs/src/RCS/s__.h,v 8.1 95/04/23 18:19:10 al Exp $
 * base class for simulation methods
 */
#define S___H
#include "u_prblst.h"

enum worst_t
   {wNONE, wWORST, wSENS, wRAND, wMAXDC, wMINDC, wMAXAC, wMINAC, wLEAD, wLAG};

class SIM{
public:
 static	double freq;		// AC frequency to analyze at (Hertz)
 static	complex jomega;		// AC frequency to analyze at (radians)
 static double time0;		// time now
 static double time1;		// time at previous time step
 static double dtmin;		// min internal step size
 static double temp;		// ambient temperature
 static double last_time;	// time at which "volts" is valid
 static int bypass_ok;		// flag: ok to bypass model evaluation
 static int inc_mode;		// flag: make incremental changes
 static worst_t worstcase;	// worst case, etc. mode
 static int mode;		// simulation type (AC, DC, ...)
 static int phase;		// phase of simulation (iter, init-dc, )
 
public:
	int stepno;		// count of visible (saved) steps
	PROBELIST alarmlist;	// list of alarm probes
	PROBELIST plotlist;	// list of plot probes
	PROBELIST printlist;	// list of print probes
	PROBELIST storelist;	// list of probes to store for postproc

protected:
	void	out(double);
	void	head(double,double,int,const char*);
	void	print(double);
	void	alarm();
	int	solve(int,int);
virtual	void	store();
};
