/* u_option.h		-*- C++ -*-
 *$Header: /al/acs/src/RCS/u_option.h,v 8.1 95/04/23 18:19:16 al Exp $
 * all the options set by the .options card.
 */

#define	mUNKNOWN	0
#define mGEAR		1	// values for method
#define mSTIFF		3
#define mTRAPEZOID	2

#define oREVERSE	1	// values for order
#define oFORWARD	2
#define oAUTO		3

#define mANALOG		1	// values for mode
#define mDIGITAL	2
#define mMIXED		3

//	NO		don't bypass 		 values for bypass
//	YES		bypass on test for both voltage and current
#define	bVOLT		2	// test for voltage only

#define	ITL_COUNT	9

class OPT {
public:
  static int acct;	    // flag: print accounting info
  static int list;	    // flag: print listing
  static int nomod;	    // flag: suppress model printout
  static int page;	    // flag: do page ejects
  static int node;	    // flag: print node table
  static int opts;	    // flag: print options
  static double gmin;	    // minimum conductance allowed
  static double reltol;	    // relative error tolerance
  static double abstol;	    // absolute current error tolerance
  static double vntol;	    // absolute voltage error tolerance
  static double trtol;	    // transient error overestimation factor
  static double chgtol;	    // charge tolerance
  static double pivtol;	    // minimum acceptable pivot
  static double pivrel;	    // max to min ratio in a column?
  static int numdgt;	    // number of digits to display
  static double tnom;	    // nominal termperature
  static int cptime;	    // max allowed cpu time (seconds)
  static int limtim;	    // amt of time to reserve for plots
  static int limpts;	    // max points to print
  static int lvlcod;	    // enum: if == 2, solve fast
  static int lvltim;	    // enum: how to control time step
  static int method;	    // enum: integration method
  static int maxord;	    // max order of integration
  static double defl;	    // MOS default channel length
  static double defw;	    // MOS default channel width
  static double defad;	    // MOS default drain diffusion area
  static double defas;	    // MOS default source diffusion area

  static int seed;	    // random number seed
  static double wczero;	    // worst case zero window
  static double damp;	    // Newton-Raphson damping coefficient
  static double floor;	    // print as 0 if less than this
  static double tempamb;    // ambient temperature
  static double shortckt;   // short resistance
  static int picky;	    // error picky-ness
  static int inwidth;	    // width of input devices
  static int outwidth;	    // width of output devices
  static double xdivisions; // plot divisions, x axis
  static double ydivisions; // plot divisions, y axis
  static int order;	    // ordering method
  static int mode;	    // mixed-mode mode preference
  static int transits;	    // number of good transitions for digital
  static int dupcheck;	    // check for duplicates on read
  static int bypass;	    // bypass model evaluation, if appropriate
  static int incmode;	    // make incremental changes to the matrix
  static int lubypass;	    // bypass parts of LU decomposition, if appropriate
  static double limit;	    // diff voltage limit for nonlinear calculations
  static double vmax;	    // + voltage limit for nonlinear calculations
  static double vmin;	    // - voltage limit for nonlinear calculations
  static double dtmin;	    // smallest internal step in transient analysis
  static double dtratio;    // ratio of max / min dt in transient analysis
  static int rstray;	    // include stray resistors in models
  static int cstray;	    // include stray capacitors in models
  static int harmonics;	    // number of harmonics in fourier analysis
  static double trstepgrow; // limit of step size growth in transient analysis
  static double trstepshrink;// amt to shrink step size on convergence failure
  static double trreject;   // how bad trunc error has to be to reject a step
  static int showall;	    // flag: show development flags
  static int foooo;	    // a reusable value to aid development
  static int diodeflags;    // convergence heuristic flags for diode
  static int mosflags;	    // convergence heuristic flags for mosfet
  
  static double lowlim;	    // 1 - reltol
  static double uplim;	    // 1 + reltol
  
  static int itl[ITL_COUNT];// 1=dc (bias) iteration limit
			    // 2=dc transfer iteration limit
			    // 3=lower transient iteration limit
			    // 4=upper transient iteration limit
			    // 5=transient total iterations allowed
			    // 6=source stepping iteration limit
			    // 7=worst case iteration limit
			    // 8=trace nonconvergence start iteration
};
